package ru.landgrafhomyak.db.serdha0.api.module

import ru.landgrafhomyak.db.serdha0.api.runtime.Transaction

public interface ModuleTemplate<@Suppress("unused") mUE : Any> {
	public interface VersionsInitializer<UE : Any> {
		public fun createModuleTemplates(context: Scope): UE

		public interface Scope {
			public fun <nmUE : Any> createTemplate(
				versionKey: String,
				constructor: ModuleConstructor<nmUE>,
			): ModuleTemplate<nmUE>

			public fun <omUE : Any, nmUE : Any> upgradeTemplate(
				versionKey: String,
				oldModule: ModuleTemplate<omUE>,
				upgrade: ModuleUpgrade<omUE, nmUE>,
			): ModuleTemplate<nmUE>

			public fun <omUE : Any, nmUE : Any> upgradeTemplateAndMerge(
				oldModule: ModuleTemplate<omUE>,
				upgrade: ModuleUpgrade<omUE, nmUE>,
				mergePoint: ModuleTemplate<nmUE>
			): ModuleTemplate<nmUE>
		}
	}

	public interface ModuleConstructor<mUE : Any> {
		public fun createSchema(context: CreateModuleScope): mUE

		public suspend fun initData(ext: mUE, transaction: Transaction) {}
	}

	public interface ModuleUpgrade<omUE : Any, nmUE : Any> {

		public fun upgradeSchema(context: UpgradeModuleScope<omUE>): nmUE

		public suspend fun upgradeData(ext: nmUE, transaction: Transaction) {}
	}

	public val versionKey: String
}